#!/usr/bin/perl -w
#The perl script is to process the result of the miPred program.
use strict;
if (@ARGV <1){
print "Usage: $0 <the result predicted by MiPred program> <prefix of the reult file names>\n";
exit;
}
my $result=$ARGV[0];
my $prefix=$ARGV[1];
my @array;
my @infile;
my ($header,$miR,$seq,$structre,$mfe);
open FH,$result;
   @infile=<FH>;
my $infile=join('',@infile);
   #$infile=~s/\n//g;
my @file=split('Sequence\sName\:\t',$infile);
close FH;

#print the three type results.
open NO,">$prefix-NotmiR";
open PS,">$prefix-Pseudo";
open YES,">$prefix-miR";
foreach my $element(@file){
   #print $element,"\n"  ;
   if($element=~/^(.*)\nSequence\sContent\:\t(.*)\nLength\:\t.*\nPre-miRNA-like\sHairpin\?\tNo.*\nThe\sSecondary\sStructure\:\t(.*)\nMFE\:\t(.*)\n/){

     $header=$1;
     $miR="No";
     $seq=$2;
     $structre=$3;
     $mfe=$4;
     print NO ">$header\n$seq\n$structre\t\(MFE:$mfe\)\n";
     }elsif($element=~/^(.*)\nSequence\sContent\:\t(.*)\nLength\:\t.*\nPre-miRNA-like\sHairpin\?\tYes.*\nThe\sSecondary\sStructure\:\t(.*)\nMFE\:\t(.*)\n.*\nPrediction\sresult.*pseudo.*\n/){
     $header=$1;
     $miR="Pseudo";
     $seq=$2;
     $structre=$3;
     $mfe=$4;    
     print PS ">$header\n$seq\n$structre\t\(MFE:$mfe\)\n";   
      }elsif($element=~/^(.*)\nSequence\sContent\:\t(.*)\nLength\:\t.*\nPre-miRNA-like\sHairpin\?\tYes.*\nThe\sSecondary\sStructure\:\t(.*)\nMFE\:\t(.*)\n.*\nPrediction\sresult.*real.*\n/){
     $header=$1;
     $miR="Yes";
     $seq=$2;
     $structre=$3;
     $mfe=$4; 
     print YES ">$header\n$seq\n$structre\t\(MFE:$mfe\)\n";     
      }
     unless(!($miR=~/Yes|Pseudo|No/)){
     push (@array,"$header\t$miR");
     }
    }
close NO;
close PS;
close YES;

open FH,">$prefix-simple_mipred_result";

print FH join("\n",@array);

close FH;